FROM alpine:3.18
LABEL MAINTAINER="All42 s.r.l. Emiliano Franchini sistemi@all42.it" 

ARG PDNS_VER

ENV POWERDNS_VERSION=$PDNS_VER \
    MYSQL_DEFAULT_AUTOCONF=true \
    MYSQL_DEFAULT_HOST="mysql" \
    MYSQL_DEFAULT_PORT="3306" \
    MYSQL_DEFAULT_USER="root" \
    MYSQL_DEFAULT_PASS="root" \
    MYSQL_DEFAULT_DB="pdns"

RUN apk --update add bash \
                     libpq \
                     sqlite-libs \
                     libstdc++ \
                     libgcc \
                     mariadb-client \
                     mariadb-connector-c \
                     lua-dev \
                     curl-dev
RUN apk add --virtual build-deps \
                      g++ \
                      make \
                      mariadb-dev \
                      postgresql-dev \
                      sqlite-dev \
                      lmdb-dev \
                      curl \
                      boost-dev \
                      mariadb-connector-c-dev 

RUN curl -sSL https://downloads.powerdns.com/releases/pdns-$POWERDNS_VERSION.tar.bz2 | tar xj -C /tmp 
    

RUN cd /tmp/pdns-$POWERDNS_VERSION && \
    ./configure --prefix="" --exec-prefix=/usr --sysconfdir=/etc/pdns \
      --with-modules="bind gmysql gpgsql gsqlite3" \
      --with-dynmodules=" lmdb" && \
    make && make install-strip && make clean && \    
    cd / && \
    mkdir -p /etc/pdns/conf.d && \
    addgroup -S pdns 2>/dev/null && \
    adduser -S -D -H -h /var/empty -s /bin/false -G pdns -g pdns pdns 2>/dev/null && \
    cp /usr/lib/libboost_program_options.so* /tmp 

RUN apk del --purge build-deps && \
    apk add boost-libs && \
    mv /tmp/lib* /usr/lib/ && \
    rm -rf /tmp/pdns-$POWERDNS_VERSION /var/cache/apk/*

ADD schema.sql pdns.conf /etc/pdns/
ADD entrypoint.sh /

EXPOSE 53/tcp 53/udp

ENTRYPOINT ["/entrypoint.sh"]
